# Copyright 2024 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# automatically generated by the FlatBuffers compiler, do not modify

# namespace: shardfile

# pylint: skip-file

import flatbuffers  # type: ignore[import-untyped]
from flatbuffers.builder import Builder
from flatbuffers.compat import import_numpy  # type: ignore[import-untyped]

from sedpack.io.flatbuffer.shardfile.Attribute import Attribute

np = import_numpy()


class Example(object):
    __slots__ = ['_tab']

    @classmethod
    def GetRootAs(cls, buf: bytes, offset: int = 0) -> "Example":
        n = flatbuffers.encode.Get(flatbuffers.packer.uoffset, buf, offset)
        x = Example()
        x.Init(buf, n + offset)
        return x

    # Example
    def Init(self, buf: bytes, pos: int) -> None:
        self._tab = flatbuffers.table.Table(buf, pos)

    # Example
    def Attributes(self, j: int) -> Attribute | None:
        o = flatbuffers.number_types.UOffsetTFlags.py_type(self._tab.Offset(4))
        if o != 0:
            x = self._tab.Vector(o)
            x += flatbuffers.number_types.UOffsetTFlags.py_type(j) * 4
            x = self._tab.Indirect(x)
            obj = Attribute()
            obj.Init(self._tab.Bytes, x)
            return obj
        return None

    # Example
    def AttributesLength(self) -> int:
        o: int = flatbuffers.number_types.UOffsetTFlags.py_type(
            self._tab.Offset(4))
        if o != 0:
            return self._tab.VectorLen(o)  # type: ignore[no-any-return]
        return 0

    # Example
    def AttributesIsNone(self) -> bool:
        o: int = flatbuffers.number_types.UOffsetTFlags.py_type(
            self._tab.Offset(4))
        return o == 0


def ExampleStart(builder: Builder) -> None:  # type: ignore[no-any-unimported]
    builder.StartObject(1)


def Start(builder: Builder) -> None:  # type: ignore[no-any-unimported]
    ExampleStart(builder)


def ExampleAddAttributes(  # type: ignore[no-any-unimported]
        builder: Builder, attributes: int) -> None:
    builder.PrependUOffsetTRelativeSlot(
        0, flatbuffers.number_types.UOffsetTFlags.py_type(attributes), 0)


def AddAttributes(  # type: ignore[no-any-unimported]
        builder: Builder, attributes: int) -> None:
    ExampleAddAttributes(builder, attributes)


def ExampleStartAttributesVector(  # type: ignore[no-any-unimported]
        builder: Builder, numElems: int) -> int:
    return builder.StartVector(4, numElems, 4)  # type: ignore[no-any-return]


def StartAttributesVector(  # type: ignore[no-any-unimported]
        builder: Builder, numElems: int) -> int:
    return ExampleStartAttributesVector(builder, numElems)


def ExampleEnd(builder: Builder) -> int:  # type: ignore[no-any-unimported]
    return builder.EndObject()  # type: ignore[no-any-return]


def End(builder: Builder) -> int:  # type: ignore[no-any-unimported]
    return ExampleEnd(builder)
